package u8c.ui.mm.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.OperationMainVO;
import nc.vo.OperationTransferVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.SpecialBillHeaderVO;
import nc.vo.ic.pub.bill.SpecialBillItemVO;
import nc.vo.ic.pub.bill.SpecialBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ValidationException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.ui.mm.panel.OperationMainPanel;
import u8c.ui.mm.panel.OperationTestUI;

public class PushTranstorAction extends AbstractAction{
	private IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private IplatFormEntry iIplatFormEntry = (IplatFormEntry) NCLocator.getInstance()
			.lookup(IplatFormEntry.class.getName());
	OperationTestUI frameUI = null;
	
	public PushTranstorAction(FrameUI frameUI) {
		super(frameUI);
		this.frameUI = (OperationTestUI) frameUI;
	}

	@Override
	public void execute() throws Exception {

		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((OperationMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();

		if (null != s && s != null) {
			OperationMainVO headvo = (OperationMainVO) s.getParentVO();
			int billstatus = headvo.getBillstatus();
			if (billstatus != 1) {
				throw new ValidationException("非审批态单据不允许生成转库单");
			}
//			ToTranStorDialog toTranStorDialog = new ToTranStorDialog(s);
//			toTranStorDialog.show();
			
			//生成转库单
			OperationTransferVO[]  operationpurs=getTranArrays(s);
			if(null==operationpurs || operationpurs.length==0) {
				throw new ValidationException("没有需要生成的转库单！");
			}else {
				IplatFormEntry iIplatFormEntry = (IplatFormEntry)NCLocator.getInstance().lookup(IplatFormEntry.class.getName());
				List<SpecialBillVO> getaggvos =getaggvos(operationpurs,headvo);
				if(null!=getaggvos && getaggvos.size()>0) {
					for(SpecialBillVO vo:getaggvos) {
						   iIplatFormEntry.processAction("WRITE", "4K", null, null, vo, null, null);
						}
					MessageDialog.showHintDlg(frameUI, "成功", "转库单新增成功!");
				}else {
					MessageDialog.showHintDlg(frameUI, "提示", "转库单没有数据!");			
				}				
			}
		}	
	}
	
	

	// 根据传入的aggvo获取tranvo数组
	private OperationTransferVO[] getTranArrays(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OperationTransferVO> tranvos = new ArrayList<OperationTransferVO>();
		for (CircularlyAccessibleValueObject vo : vos) {
			if (vo instanceof OperationTransferVO) {
				// 本次执行数量不填就默认
				// 执行完的表体在生单界面不展示
				OperationTransferVO tranvo = (OperationTransferVO) vo;
				UFDouble num = tranvo.getNum() == null ? UFDouble.ZERO_DBL : tranvo.getNum();
				UFDouble execnum = tranvo.getExecnum() == null ? UFDouble.ZERO_DBL : new UFDouble(tranvo.getExecnum());
				if (num.sub(execnum).compareTo(UFDouble.ZERO_DBL) == 0) {
					continue;
				}
				tranvo.setVdef2(num.sub(execnum).setScale(2, UFDouble.ROUND_HALF_UP).toString());
				tranvos.add(tranvo);
			}
		}
		OperationTransferVO[] tranArrays = tranvos.toArray(new OperationTransferVO[0]);
		return tranArrays;
	}
	
	
	
	private  List<SpecialBillVO> getaggvos(OperationTransferVO[] opervos,OperationMainVO headvo) throws Exception{
		Map<String,List<OperationTransferVO>> map=new HashMap<String,List<OperationTransferVO>>();//key 转库需求单主键
		for(int i=0;i<opervos.length;i++) {
			OperationTransferVO cagvo=opervos[i];
			List<OperationTransferVO> vos=map.get(cagvo.getVdef29());//TODO换成主键
			if(null!=vos && vos.size() >0 ) {
				vos.add(cagvo);
				map.put(cagvo.getVdef29(), vos);
			}else {
				List<OperationTransferVO> vosnew=new ArrayList<OperationTransferVO>();
				vosnew.add(cagvo);
				map.put(cagvo.getVdef29(), vosnew);
			}
		}
		
		 List<SpecialBillVO> aggvos=new ArrayList<SpecialBillVO>();
		 for (Map.Entry<String,List<OperationTransferVO>> entry : map.entrySet()) {
			 SpecialBillVO aggvo = new SpecialBillVO();
			 SpecialBillHeaderVO header = new SpecialBillHeaderVO();
				// 表头赋值
			 header.setCbilltypecode("4K");
	//			headvo.setCinwarehouseid("1001V51000000000039Z");// 入库仓库ID 工装
			 header.setCinwarehouseid(getstordocpk("GZ001"));//入仓库必填
			 header.setCoperatorid(ClientEnvironment.getInstance().getUser().getPrimaryKey());
	//			headvo.setCoutwarehouseid("1001V5100000000003A1");// 出库仓库ID 家装
			 header.setCoutwarehouseid(getstordocpk("GG003"));//仓库必填
			 header.setCshlddiliverdate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
			 header.setDbilldate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
			 header.setFbillflag(2);
			 header.setIcheckmode(4);
			 header.setIPrintCount(0);
			 header.setPk_corp(PubEnv.getCorpCode());
			 header.setVshldarrivedate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
			 	/***************************/
				//项目编码 pk_defdoc9
				header.setAttributeValue("pk_defdoc9", headvo.getProjectid());
				//项目名称pk_defdoc10
				header.setAttributeValue("pk_defdoc10", headvo.getProjectid());
				//加工单号pk_defdoc2
				header.setAttributeValue("pk_defdoc2", entry.getKey());
				 /***************************/
			 //表体
				List<OperationTransferVO> lispurvos=entry.getValue();
				SpecialBillItemVO[] items = new SpecialBillItemVO[lispurvos.size()];
				for(int j=0;j<lispurvos.size();j++) {
					OperationTransferVO zbvo=lispurvos.get(j);
					SpecialBillItemVO billitem = new SpecialBillItemVO();
					String cmaterialcode = zbvo.getCmaterialcode();//
					billitem.setCinventoryid(getCmangchid(getCmangid(cmaterialcode)));
					billitem.setAttributeValue("pk_corp",PubEnv.getCorpCode());//公司
					billitem.setAttributeValue("pk_defdoc1",zbvo.getVdef1() );//楼号楼层
					billitem.setAttributeValue("pk_defdoc2", zbvo.getVdef2());//樘数（数量）
					billitem.setAttributeValue("pk_defdoc3", zbvo.getVdef3());//框统计
					billitem.setAttributeValue("pk_defdoc4", zbvo.getVdef4());//扇统计
					billitem.setAttributeValue("pk_defdoc5", zbvo.getVdef5());//半成品分类
					billitem.setAttributeValue("pk_defdoc6", zbvo.getVdef6());//面积
					billitem.setAttributeValue("pk_defdoc7", zbvo.getVdef7());//切割长度
					billitem.setAttributeValue("pk_defdoc8", zbvo.getVdef8());//切割角度左下
					billitem.setAttributeValue("pk_defdoc9", zbvo.getVdef9());//切割角度右上
					billitem.setAttributeValue("pk_defdoc10",zbvo.getVdef10());//备注
					billitem.setAttributeValue("pk_defdoc11",zbvo.getWidth());//宽度
					billitem.setAttributeValue("pk_defdoc12",zbvo.getHeight());//高度
					billitem.setAttributeValue("pk_defdoc13",zbvo.getVdef11());//系列
					billitem.setAttributeValue("pk_defdoc14",zbvo.getVdef12());//玻璃编号
//					billitem.setVbatchcode (zbvo.getOutvbatchcode());//批次号——转出批次
					billitem.setVbatchcode (zbvo.getInvbatchcode());//批次号——转出批次
					billitem.setVfree1(zbvo.getColor());
					billitem.setVfree2(zbvo.getAlloy());
					billitem.setVfree3(zbvo.getSizing());
					billitem.setVfree4(zbvo.getStandard());
					billitem.setCastunitid(getMeasidByNames(zbvo.getCastunitid()));//辅计量单位ID 
				//	billitem.setDshldtransnum(zbvo.getNum());//数量
					billitem.setDshldtransnum(new UFDouble(zbvo.getVdef26()));//数量
					billitem.setNshldtransastnum(zbvo.getNastnum());//应转辅数量 
					items[j]=billitem;
				}
				aggvo.setParentVO(header);
				aggvo.setChildrenVO(items);
				aggvos.add(aggvo);
		    }
		  return aggvos;
	}
	
	
	
	/**
	 * 根据物料code查询主键
	 * 
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangid(String code) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invbasdoc from bd_invbasdoc" + " where invcode  ='" + code + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + code);
		}
		return cmangid;
	}

	/**
	 * 存货管理档案
	 * 
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangchid(String pk_invbasdoc) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invmandoc from bd_invmandoc" + " where pk_invbasdoc  ='" + pk_invbasdoc
				+ "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + pk_invbasdoc);
		}
		return cmangid;
	}
	
	  public  String getstordocpk(String storcode)throws Exception{
	    	String sql = "select pk_stordoc from bd_stordoc where storcode = '"+storcode+"'";
	    	String pk_stordoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
	    	if(pk_stordoc == null) {
	    		throw new Exception("仓库"+storcode+"未查到，请检查");
	    	}
	    	return pk_stordoc;
	    }
	

		//根据计量单位名称获取主键
	    public  String getMeasidByNames(String measname) throws Exception {
	        String sql = "select pk_measdoc from bd_measdoc where isnull(dr,0) = 0 and measname = '"+measname+"'";
	        return (String) iuap.executeQuery(sql, new ColumnProcessor());
	    }

}
